CAD开发者社区

 找回密码
 立即注册

QQ登录

只需一步,快速开始

ActiveX 开发指南

相关分类

HandleToObject Method (ActiveX)

2023-1-4 06:17| 发布者: admin| 查看: 513| 评论: 0|来自: AutoCAD

摘要: 获取与给定句柄对应的对象。

获取与给定句柄对应的对象。

支持的平台:仅窗口

签名

工 务 局:

RetVal = object.HandleToObject(Handle)
对象

类型:文档

此方法适用的对象。

处理

访问:仅输入

类型:字符串

要返回的对象的句柄。

返回值(RetVal)

类型:对象

与给定句柄对应的对象。

言论

此方法只能返回当前文档中的对象。

例子

工 务 局:

Sub Example_HandleToObject()
    ' This example creates a spline in model space, and returns the
    ' handle for the spline. Then the spline is returned from the handle and colored.
    
    ' Create the spline
    Dim splineObj As AcadSpline
    Dim startTan(0 To 2) As Double
    Dim endTan(0 To 2) As Double
    Dim fitPoints(0 To 8) As Double
    
    startTan(0) = 0.5: startTan(1) = 0.5: startTan(2) = 0
    endTan(0) = 0.5: endTan(1) = 0.5: endTan(2) = 0
    fitPoints(0) = 1: fitPoints(1) = 1: fitPoints(2) = 0
    fitPoints(3) = 5: fitPoints(4) = 5: fitPoints(5) = 0
    fitPoints(6) = 10: fitPoints(7) = 0: fitPoints(8) = 0
    Set splineObj = ThisDrawing.ModelSpace.AddSpline(fitPoints, startTan, endTan)
    
    ZoomAll
    
    ' Find the handle of the spline
    Dim handle As String
    handle = splineObj.handle
    MsgBox "The handle of the Spline is: " & splineObj.handle, , "HandleToObject Example"
        
    ' Find an object from a given handle
    Dim tempObj As AcadObject
    Set tempObj = ThisDrawing.HandleToObject(handle)

    ' Now use the newly initialized object variable to color the object 
    Dim color As AcadAcCmColor
    Set color = AcadApplication.GetInterfaceObject("AutoCAD.AcCmColor." & Left(AcadApplication.Version, 2))
    Call color.SetRGB(80, 100, 244)
    
    tempObj.TrueColor = color
    
    ThisDrawing.Regen True
    MsgBox "The Spline is now blue.", , "ObjectIDToObject Example"
    
End Sub

Visual LISP:

(vl-load-com)
(defun c:Example_HandleToObject()
    ;; This example creates a spline in model space, and returns the
    ;; handle for the spline. Then the spline is returned from the handle and colored.
    (setq acadObj (vlax-get-acad-object))
    (setq doc (vla-get-ActiveDocument acadObj))
    
    ;; Create the spline
    (setq startTan (vlax-3d-point 0.5 0.5 0)
          endTan (vlax-3d-point 0.5 0.5 0)
          fitPoints (vlax-make-safearray vlax-vbDouble '(0 . 8)))
    (vlax-safearray-fill fitPoints '(1 1 0
                                     5 5 0
				                                 10 0 0
				                                )
    )
    (setq modelSpace (vla-get-ModelSpace doc))
    (setq splineObj (vla-AddSpline modelSpace fitPoints startTan endTan))
    (vla-ZoomAll acadObj)
    
    ;; Find the handle of the spline
    (setq handle (vla-get-Handle splineObj))
    (alert (strcat "The handle of the Spline is: " handle))
        
    ;; Find an object from a given handle
    (setq tempObj (vla-HandleToObject doc handle))

    ;; Now use the newly initialized object variable to color the object
    (setq color (vlax-create-object (strcat "AutoCAD.AcCmColor." (substr (getvar "ACADVER") 1 2))))
    (vla-SetRGB color 80 100 244)
    (vla-put-TrueColor tempObj color)
    
    (vla-Regen doc :vlax-true)
    (alert "The Spline is now blue.")
    (vlax-release-object color)
)

路过

雷人

握手

鲜花

鸡蛋

最新评论

QQ|Archiver|CAD开发者社区 ( 苏ICP备2022047690号-1 )

GMT+8, 2024-5-11 15:13

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

返回顶部